#!/usr/local/bin/pike -w

/*** example code for using nntpobjects in pike
 ***
 *** Author: Niels van Sluis, <N.vanSluis@amc.uva.nl>
 ***
 ***/

int main() {
  object myserver = .news_server.news_server();
  object myconnection = .news_connection.news_connection();
  object mygroups = .news_groups.news_groups();
  object myarticles = .news_articles.news_articles();
  object myservers = .news_servers.news_servers();

  myserver->news_server("news.amc.uva.nl",119);
  myconnection->setDebug();
  myconnection->news_connection(myserver);
  mygroups = myconnection->listGroups();

  mygroups->saveGroups("/tmp/list.txt");


  while(!mygroups->isEmpty()) {
    object mygroup = mygroups->getGroup();
    write("%s\n",mygroup->getName());
  }


  return 0;
}
