/***************************************************************************
 *** news_server.pike
 ***
 *** based on news_server.cpp from Fred, <fred@ceylana.com>
 *** ported to pike by Niels van Sluis, <n.vansluis@amc.nl>
 *** Tue Aug 15 2002, newsobjects-0.9.3
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#define false 	0
#define	true	1

class news_server {
  string class_id = "news_server";
  private string phost;
  private string puser;
  private string ppass;
  private int pport;

  void create(void|string a, void|string|int b, void|string c, void|string d) {
    news_server(a,b,c,d);
  }

  void news_server(void|string a, void|string|int b,
                   void|string c, void|string d) {
    if(stringp(a) && intp(b) && stringp(c) && stringp(d)) { 
    //
    // news_server(string host, int port, string user, string pass);
    //
    // Use this constructor if you need to enter a non-standard port and a
    // username and password.
    //
      string host = a;
      int port = b;
      string user = c;
      string pass = d;

      setHost(host);
      setPass(pass);
      setPort(port);
      setUser(user);
 
      return;
    }

    if(stringp(a) && intp(b)) {
    //
    // news_server(string host, int port);
    //
    // Use this constructor if the server does not require authentication,
    // but uses a non standard port.
    //

      string host = a;
      int port = b;
        
      setHost(host);
      setPass("");
      setPort(port);
      setUser("");

      return;
    }

    if(stringp(a) && stringp(b) && stringp(c)) {
    //
    // news_server(string host, string user, string pass);
    //
    // Use this constructor if the server uses the standard port but requires
    // authentication.
    //
   
      string host = a; 
      string user = b; 
      string pass = c;
 
      setHost(host);
      setPass(pass);
      setPort(119);
      setUser(user);
  
      return;
    }

    if(stringp(a)) {
    //
    // news_server(string host);
    //
   
       string host = a;
 
       setHost(host);
       setPass("");
       setPort(119);
       setUser("");

       return;
    }

    //
    // news_server();
    // 
    // This is the default constructor, which creates a news_server with
    // default values.
    //
 
      setHost("localhost");
      setPass("");
      setPort(119);
      setUser("");

      return;
  }

  int setHost(string host) {
  //
  // Set the server host with a string containing a domain name (example.com)
  // or an ip address (127.0.0.1).
  //

    phost = host;
    return true;
  }

  int setPort(string|int port) {
  //
  // setPort(int port);
  // setPort(string port);
  //
  // Set the port with an integer or string. This defaults to 119 and should
  // not need to be changed in most circumstances.
  //

    pport = (int)port;
    return true;
  }

  int setUser(string user) {
  //
  // Set the username with a string only if required to connect.
  //

    puser = user;
    return true;
  }

  int setPass(string pass) {
  //
  // Set the password with a string only if required to connect.
  //

    ppass = pass;
    return true;
  }

  string getHost() {
  //
  // Returns the hostname as a string.  This does not resolve host to ip.
  //

    return phost;
  }

  string getPass() {
  //
  // Returns the password as a sting or an empty string if there is no password
  //

    return ppass;
  }

  string getUser() {
  //
  // Returns the username as a string or an empty string if there is no 
  // username.
  //

    return puser;
  }

  int getPort() {
  //
  // Returns the port number as an integer.
  //

    return pport;
  } 
};
