/***************************************************************************
 *** news_servers.pike
 ***
 *** based on news_servers.cpp from Fred, <fred@ceylana.com>
 *** ported to pike by Niels van Sluis, <n.vansluis@amc.nl>
 *** Tue Aug 15 2002, newsobjects-0.9.3
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#define false 	0
#define	true	1

class news_servers {
  string class_id ="news_servers";

  private object head;
  private object needle;
  private object tail;

  void create() {
    news_servers();
  }

  void news_servers() {
  }

  int addServer(object server) {
  //
  // Add a server to the collection.
  //

    if(!head) {
      head = .std_dataobject.std_dataobject();
      head->data = server;
      needle = head;
      tail = head;
    } else {
      needle->next = .std_dataobject.std_dataobject();
      needle->next->prev = needle;
      needle = needle->next;
      needle->data = server;
      tail = needle;
    }

  }

  object getServer() {
  //
  // Get a server from the collection.  This function returns the first
  // server from the collection and removes it from the collection.
  //
    object temp = head->data;
    if(head->next) head = head->next;
    return temp;
  }
};
