/***************************************************************************
 *** std_dataobject.pmod
 ***
 *** This module is used when making linked list instead of arrays holding
 *** article, group or server collections. Linked list seems to be a lot
 *** faster in Pike then using arrays. This is probably since there are no
 *** standard pop and push functions in pike.
 *** 
 *** Created by Niels van Sluis, <n.vansluis@amc.nl>
 *** Tue Aug 15 2002
 ***************************************************************************/

class std_dataobject {
  object data;

  object next;
  object prev;

  void create(void|object o) {
    data = o;
  }
};
